OGRE: Ogre::ExternalTextureSource Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Member Functions | Static Public Member Functions | List of all members
Ogre::ExternalTextureSource Class Referenceabstract
Core » Materials

IMPORTANT: Plugins must override default dictionary name! Base class that texture plugins derive from. More...

`#include <OgreExternalTextureSource.h>`

Inheritance diagram for Ogre::ExternalTextureSource:
[legend]

## Classes
class | CmdFPS
class | CmdInputFileName
class | CmdPlayMode
class | CmdTecPassState

## Public Member Functions
| ExternalTextureSource ()
| Constructor. More...
virtual | ~ExternalTextureSource ()
| Virtual destructor. More...
void | addBaseParams ()
| Call from derived classes to ensure the dictionary is setup. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual void | createDefinedTexture (const String &sMaterialName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)=0
| Creates a texture into an already defined material or one that is created new (it's up to plugin to use a material or create one) Before calling, ensure that needed params have been defined via the stringInterface or regular methods. More...
virtual void | destroyAdvancedTexture (const String &sTextureName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)=0
| What this destroys is dependent on the plugin... More...
const String & | getDictionaryStringName (void) const
| Returns dictionary name. More...
int | getFPS () const
| Gets currently set frames per second. More...
const String & | getInputName () const
| Gets currently set input file name. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
eTexturePlayMode | getPlayMode () const
| Gets currently set play mode. More...
const String & | getPluginStringName (void) const
| Returns the string name of this Plugin (as set by the Plugin) More...
void | getTextureTecPassStateLevel (int &t, int &p, int &s) const
| Get currently selected Texture attribs. More...
virtual bool | initialise ()=0
| Call this function from manager to init system. More...
void | setFPS (int iFPS)
| Sets the frames per second - plugin may or may not use this. More...
void | setInputName (const String &sIN)
| Sets an input file name - if needed by plugin. More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
void | setPlayMode (eTexturePlayMode eMode)
| Sets a play mode. More...
void | setTextureTecPassStateLevel (int t, int p, int s)
| Used for attaching texture to Technique, State, and texture unit layer. More...
virtual void | shutDown ()=0
| Shuts down Plugin. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Detailed Description

IMPORTANT: Plugins must override default dictionary name! Base class that texture plugins derive from.

Any specific requirements that the plugin needs to have defined before texture/material creation must be define using the stringinterface before calling create defined texture... or it will fail, though, it is up to the plugin to report errors to the log file, or raise an exception if need be.

## Constructor & Destructor Documentation

## ◆ ExternalTextureSource()

Ogre::ExternalTextureSource::ExternalTextureSource | ( |  | ) |

Constructor.

## ◆ ~ExternalTextureSource()

virtual Ogre::ExternalTextureSource::~ExternalTextureSource | ( |  | ) |
| inlinevirtual

Virtual destructor.

## Member Function Documentation

## ◆ addBaseParams()

void Ogre::ExternalTextureSource::addBaseParams | ( |  | ) |

Call from derived classes to ensure the dictionary is setup.

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ createDefinedTexture()

virtual void Ogre::ExternalTextureSource::createDefinedTexture | ( | const String & | sMaterialName,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) |  |
| pure virtual

Creates a texture into an already defined material or one that is created new (it's up to plugin to use a material or create one) Before calling, ensure that needed params have been defined via the stringInterface or regular methods.

## ◆ destroyAdvancedTexture()

virtual void Ogre::ExternalTextureSource::destroyAdvancedTexture | ( | const String & | sTextureName,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) |  |
| pure virtual

What this destroys is dependent on the plugin...

See specific plugin doc to know what is all destroyed (normally, plugins will destroy only what they created, or used directly - ie. just texture unit)

## ◆ getDictionaryStringName()

const String& Ogre::ExternalTextureSource::getDictionaryStringName | ( | void |  | ) | const
| inline

Returns dictionary name.

## ◆ getFPS()

int Ogre::ExternalTextureSource::getFPS | ( |  | ) | const
| inline

Gets currently set frames per second.

## ◆ getInputName()

const String& Ogre::ExternalTextureSource::getInputName | ( |  | ) | const
| inline

Gets currently set input file name.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getPlayMode()

eTexturePlayMode Ogre::ExternalTextureSource::getPlayMode | ( |  | ) | const
| inline

Gets currently set play mode.

## ◆ getPluginStringName()

const String& Ogre::ExternalTextureSource::getPluginStringName | ( | void |  | ) | const
| inline

Returns the string name of this Plugin (as set by the Plugin)

## ◆ getTextureTecPassStateLevel()

void Ogre::ExternalTextureSource::getTextureTecPassStateLevel | ( | int & | t,
|  | int & | p,
|  | int & | s
| ) |  | const
| inline

Get currently selected Texture attribs.

## ◆ initialise()

virtual bool Ogre::ExternalTextureSource::initialise | ( |  | ) |
| pure virtual

Call this function from manager to init system.

## ◆ setFPS()

void Ogre::ExternalTextureSource::setFPS | ( | int | iFPS | ) |
| inline

Sets the frames per second - plugin may or may not use this.

## ◆ setInputName()

void Ogre::ExternalTextureSource::setInputName | ( | const String & | sIN | ) |
| inline

Sets an input file name - if needed by plugin.

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setPlayMode()

void Ogre::ExternalTextureSource::setPlayMode | ( | eTexturePlayMode | eMode | ) |
| inline

Sets a play mode.

## ◆ setTextureTecPassStateLevel()

void Ogre::ExternalTextureSource::setTextureTecPassStateLevel | ( | int | t,
|  | int | p,
|  | int | s
| ) |  |
| inline

Used for attaching texture to Technique, State, and texture unit layer.

## ◆ shutDown()

virtual void Ogre::ExternalTextureSource::shutDown | ( |  | ) |
| pure virtual

Shuts down Plugin.

The documentation for this class was generated from the following file:

- OgreExternalTextureSource.h